import numpy as np
from modshogun import EuclideanDistance
from modshogun import Hierarchical
from modshogun import RealFeatures
from modshogun import SerializableAsciiFile
from modshogun import WrappedObjectArray
from modshogun import CSVFile

f_feats_train = CSVFile("../../data/classifier_4class_2d_linear_features_train.dat")

#![create_features]
features_train = RealFeatures(f_feats_train)
#![create_features]

#![choose_distance]
distance = EuclideanDistance(features_train, features_train)
#![choose_distance]

#![create_instance]
merges = 3
hierarchical = Hierarchical(merges, distance)
#![create_instance]

#![train_model]
hierarchical.train()
#![train_model]

#![extract_results]
d = hierarchical.get_merge_distances()
cp = hierarchical.get_cluster_pairs()
#![extract_results]

# Serialize output for integration testing (automatically generated)
__sg_storage = WrappedObjectArray()
__sg_storage_file = SerializableAsciiFile("hierarchical.dat", 'w')
__sg_storage.append_wrapped_int(merges, "merges")
__sg_storage.append_wrapped_real_vector(d, "d")
__sg_storage.save_serializable(__sg_storage_file)
