import numpy as np
from modshogun import RealFeatures
from modshogun import SerializableAsciiFile
from modshogun import CSVFile
from modshogun import EuclideanDistance
from modshogun import WrappedObjectArray
from modshogun import Math
from modshogun import KMeansMiniBatch
from modshogun import KMeans

f_feats_train = CSVFile("../../data/classifier_binary_2d_linear_features_train.dat")
Math.init_random(1)

#![create_features]
features_train = RealFeatures(f_feats_train)
#![create_features]

#![choose_distance]
distance = EuclideanDistance(features_train, features_train)
#![choose_distance]

#![create_instance_lloyd]
kmeans = KMeans(2, distance)
#![create_instance_lloyd]

#![train_dataset]
kmeans.train()
#![train_dataset]

#![extract_centers_and_radius]
c = kmeans.get_cluster_centers()
r = kmeans.get_radiuses()
#![extract_centers_and_radius]

#![create_instance_mb]
kmeans_mb = KMeansMiniBatch(2, distance)
kmeans_mb.set_mb_params(4, 1000)
#![create_instance_mb]

# Serialize output for integration testing (automatically generated)
__sg_storage = WrappedObjectArray()
__sg_storage_file = SerializableAsciiFile("kmeans.dat", 'w')
__sg_storage.append_wrapped_real_matrix(c, "c")
__sg_storage.append_wrapped_real_vector(r, "r")
__sg_storage.save_serializable(__sg_storage_file)
