import numpy as np
from modshogun import RealFeatures
from modshogun import SerializableAsciiFile
from modshogun import WrappedObjectArray
from modshogun import ManhattanMetric
from modshogun import CSVFile

f_feats_a = CSVFile("../../data/fm_train_real.dat")
f_feats_b = CSVFile("../../data/fm_test_real.dat")

#![create_features]
features_a = RealFeatures(f_feats_a)
features_b = RealFeatures(f_feats_b)
#![create_features]

#![create_instance]
distance = ManhattanMetric(features_a, features_a)
#![create_instance]

#![extract_distance]
distance_matrix_aa = distance.get_distance_matrix()
#![extract_distance]

#![refresh_distance]
distance.init(features_a, features_b)
distance_matrix_ab = distance.get_distance_matrix()
#![refresh_distance]

# Serialize output for integration testing (automatically generated)
__sg_storage = WrappedObjectArray()
__sg_storage_file = SerializableAsciiFile("manhattan.dat", 'w')
__sg_storage.append_wrapped_real_matrix(distance_matrix_aa, "distance_matrix_aa")
__sg_storage.append_wrapped_real_matrix(distance_matrix_ab, "distance_matrix_ab")
__sg_storage.save_serializable(__sg_storage_file)
