import numpy as np
from modshogun import WrappedObjectArray
from modshogun import MulticlassLabels
from modshogun import CSVFile
from modshogun import GaussianNaiveBayes
from modshogun import SerializableAsciiFile
from modshogun import RealFeatures

f_feats_train = CSVFile("../../data/classifier_4class_2d_linear_features_train.dat")
f_feats_test = CSVFile("../../data/classifier_4class_2d_linear_features_test.dat")
f_labels_train = CSVFile("../../data/classifier_4class_2d_linear_labels_train.dat")

#![create_features]
features_train = RealFeatures(f_feats_train)
features_test = RealFeatures(f_feats_test)
labels_train = MulticlassLabels(f_labels_train)
#![create_features]


#![create_instance]
gnb = GaussianNaiveBayes(features_train, labels_train)
#![create_instance]

#![train_and_apply]
gnb.train()
labels_predict = gnb.apply_multiclass(features_test)
#![train_and_apply]


# integration testing variables
output = labels_predict.get_labels()

# Serialize output for integration testing (automatically generated)
__sg_storage = WrappedObjectArray()
__sg_storage_file = SerializableAsciiFile("gaussian_naive_bayes.dat", 'w')
__sg_storage.append_wrapped_real_vector(output, "output")
__sg_storage.save_serializable(__sg_storage_file)
